//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_color3  Lime
#property indicator_color4  Red
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int	  CCI_Period		= 10;
extern int    CCI_Price       = 5;
extern int    Overbought		= 190;
extern int	  Oversold			= -190;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 

double ccihu[];
double ccihd[];
double ccihbu[];
double ccihbd[];
double cci[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ccihu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ccihd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ccihbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ccihbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,cci);
   SetIndexBuffer(5,trend);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         cci[i] = iCCI(NULL,0,CCI_Period,CCI_Price,i);
         ccihu[i]  = EMPTY_VALUE; 
         ccihd[i]  = EMPTY_VALUE;
         ccihbu[i] = EMPTY_VALUE;
         ccihbd[i] = EMPTY_VALUE;
         trend[i]  = 0;
            if (cci[i]>Overbought) trend[i] =  1;
            if (cci[i]<Oversold)   trend[i] = -1;
              if (trend[i]== 1)
              {
                 ccihu[i]  = High[i]; 
                 ccihd[i]  = Low[i];
                 ccihbu[i] = MathMax(Open[i],Close[i]);
                 ccihbd[i] = MathMin(Open[i],Close[i]);
              }               
              if (trend[i]== -1)
              {
                 ccihu[i]  = Low[i];
                 ccihd[i]  = High[i];
                 ccihbu[i] = MathMin(Open[i],Close[i]);
                 ccihbd[i] = MathMax(Open[i],Close[i]);
              }           
      }
      
      //
	   //
	   //
	   //
	   //
	
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("overbought");
         else  doAlert("oversold");       
      }
return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," cci cross " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," cci cross "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
   